#!/usr/bin/python

import sys
import os.path

def to_stdlogicvector(i, bits):
    return bin((1<<bits)+i)[3:3+bits]

def bfas(bfs_file, S_file):
    prog = open(bfs_file, 'r')
    out_stream = open(S_file, 'w')
    out_words = []
    refs = {}
    labels = {}
            
    for line in prog:
        tokens = [x.strip() for x in line.split(' ')]
        if tokens[0] == 'NOP':
            out_words.append(0b0000000111111010)
        elif tokens[0] == 'LD' and tokens[1] == 'A':
            out_words.append(0b0000000101111110)
        elif tokens[0] == 'ST' and tokens[1] == 'A':
            out_words.append(0b0000000011111000)
        elif tokens[0] == 'INC' and tokens[1] == 'A':
            out_words.append(0b0000000110011010)
        elif tokens[0] == 'DEC' and tokens[1] == 'A':
            out_words.append(0b0000000110111010)
        elif tokens[0] == 'INC' and tokens[1] == 'P':
            out_words.append(0b0000000111010010)
        elif tokens[0] == 'DEC' and tokens[1] == 'P':
            out_words.append(0b0000000111110010)
        elif tokens[0] == 'CLR' and tokens[1] == 'A':
            out_words.append(0b0000000101111010)
        elif tokens[0] == 'OUT' and tokens[1] == 'A':
            out_words.append(0b0000001011111010)
        elif tokens[0] == 'IN' and tokens[1] == 'A':
            out_words.append(0b0000000111111010)
        elif tokens[0] == 'JZ':
            label = tokens[1]
            refs[len(out_words)] = label
            out_words.append(0x0000000000000001)
        elif tokens[0][-1] == ':':
            labels[tokens[0][:-1]] = len(out_words)
        else:
            print "unrecognized line: %s" % line
    
    # resolve label references
    for addr in refs:
        label = refs[addr]
        if label not in labels:
            print "reference to undefined symbol %s at %d" % (label, addr)
        else:
            out_words[addr] = 2*labels[label] + 1

    for word in out_words:
        out_stream.write(to_stdlogicvector(word, 16) + "\n")
    i = len(out_words)
    while i < 65536:
        out_stream.write("0" * 16 + "\n")
        i += 1

if __name__ == '__main__':
    if len(sys.argv) != 3:
        print "usage: %s file.bfs file.dat" % sys.argv[0]
        sys.exit(1)

    bfas(sys.argv[1], sys.argv[2])
