#!/usr/bin/python

import sys
import os.path

def bfas(bfs_file, S_file):
    prog = open(bfs_file, 'r')
    crt = open(os.path.dirname(sys.argv[0]) + '/x86_crt.S', 'r')
    out_stream = open(S_file, 'w')
            
    out_stream.write(".text\n")
    out_stream.write(".globl _start\n")
    out_stream.write("_start:\n")
    out_stream.write("\txorl %ebx, %ebx\n")
    
    for line in prog:
        tokens = [x.strip() for x in line.split(' ')]
        if tokens[0] == 'NOP':
            out_stream.write("\tnop\n")
        elif tokens[0] == 'LD' and tokens[1] == 'A':
            out_stream.write("\tmovb ram(%ebx), %al\n")
        elif tokens[0] == 'ST' and tokens[1] == 'A':
            out_stream.write("\tmovb %al, ram(%ebx)\n")
        elif tokens[0] == 'INC' and tokens[1] == 'A':
            out_stream.write("\tinc %al\n")
        elif tokens[0] == 'DEC' and tokens[1] == 'A':
            out_stream.write("\tdec %al\n")
        elif tokens[0] == 'INC' and tokens[1] == 'P':
            out_stream.write("\tinc %ebx\n")
        elif tokens[0] == 'DEC' and tokens[1] == 'P':
            out_stream.write("\tdec %ebx\n")
        elif tokens[0] == 'CLR' and tokens[1] == 'A':
            out_stream.write("\txorl %eax, %eax\n")
        elif tokens[0] == 'OUT' and tokens[1] == 'A':
            out_stream.write("\tcall output\n")
        elif tokens[0] == 'IN' and tokens[1] == 'A':
            out_stream.write("\tcall input\n")
        elif tokens[0] == 'JZ':
            out_stream.write("\tcmpb $0, %al\n")
            out_stream.write("\tjz %s\n" % tokens[1])
        elif tokens[0][-1] == ':':
            out_stream.write("%s\n" % tokens[0])
        else:
            print "unrecognized line: %s" % line
    
    out_stream.write("\tcall exit\n")
    out_stream.write(crt.read()) 

    out_stream.write(".data\n")
    out_stream.write("ram:\n")
    out_stream.write(".fill 10240\n")
    out_stream.write("buf:\n")
    out_stream.write(".fill 1\n")

if __name__ == '__main__':
    if len(sys.argv) != 3:
        print "usage: %s file.bfs file.S" % sys.argv[0]
        sys.exit(1)

    bfas(sys.argv[1], sys.argv[2])
