#!/usr/bin/python

import sys

def bfc(bf_file, bfs_file):
    out_stream = open(bfs_file, 'w')
    prog = open(bf_file, 'r').read()
    loop_number = 0
    loops = []

    for char in prog:
        if char == '<':
            out_stream.write("\tDEC P\n")
        elif char == '>':
            out_stream.write("\tINC P\n")
        elif char == '-':
            out_stream.write("\tLD A\n")
            out_stream.write("\tDEC A\n")
            out_stream.write("\tST A\n")
        elif char == '+':
            out_stream.write("\tLD A\n")
            out_stream.write("\tINC A\n")
            out_stream.write("\tST A\n")
        elif char == '.':
            out_stream.write("\tLD A\n")
            out_stream.write("\tOUT A\n")
        elif char == ',':
            out_stream.write("\tIN A\n")
            out_stream.write("\tST A\n")
        elif char == '[':
            out_stream.write("loop_%d:\n" % loop_number)
            out_stream.write("\tLD A\n")
            out_stream.write("\tJZ end_loop_%d\n" % loop_number)
            loops.append(loop_number)
            loop_number += 1
        elif char == ']':
            loop = loops.pop()
            out_stream.write("\tCLR A\n")
            out_stream.write("\tJZ loop_%d\n" % loop)
            out_stream.write("end_loop_%d:\n" % loop)

if __name__ == '__main__':
    if len(sys.argv) != 3:
        print "usage: %s file.bf file.bfs" % sys.argv[0]
        sys.exit(1)

    bfc(sys.argv[1], sys.argv[2])
