#include <Arduino.h>
#include <HardwareSerial.h>
#include <stdio.h>

static uint8_t uart_echo = 1;

static FILE uart_input, uart_output;
int uart_putchar(char c, FILE *stream)
{
    Serial.write(c);
    return 0;
}
int uart_getchar(FILE *stream)
{
    int c = -1;
    while(c == -1)
    {
        c = Serial.read();
    }
    if(uart_echo)
    {
        uart_putchar(c, stdout);
    }
    return c;
}

void uart_init(void)
{
    Serial.begin(115200);
    fdev_setup_stream(&uart_output, uart_putchar, NULL, _FDEV_SETUP_WRITE); 
    fdev_setup_stream(&uart_input, NULL, uart_getchar, _FDEV_SETUP_READ); 
    stdout = &uart_output;
    stdin  = &uart_input;
}

void uart_set_echo(uint8_t e)
{
    uart_echo = e;   
}
