library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity adder is

    generic (
        WIDTH : integer;
        DELAY : time
    ); 

    port (
        a        : in std_logic_vector (WIDTH-1 downto 0);
        b        : in std_logic_vector (WIDTH-1 downto 0);
        s        : out std_logic_vector (WIDTH-1 downto 0);
        c_out    : out std_logic;
        c_in     : in std_logic
    );

end adder;

architecture rtl of adder is
   
    signal r : std_logic_vector(WIDTH downto 0);

begin

    r <= std_logic_vector(('0' & unsigned(a)) + unsigned(b) + ('0', c_in)) after DELAY;
    s <= r(WIDTH-1 downto 0);
    c_out <= r(WIDTH);

end rtl;
