library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity counter is

	generic (
		WIDTH : integer;
        DELAY : time
	); 

	port (
		output   : out std_logic_vector (WIDTH-1 downto 0);
		zero	 : out std_logic;
		input    : in std_logic_vector (WIDTH-1 downto 0);
		up		 : in std_logic;
		down	 : in std_logic;
		reset	 : in std_logic;
		preset	 : in std_logic
	);

end counter;

architecture rtl of counter is
	
	signal reg : unsigned (WIDTH-1 downto 0);
	
begin
  
  process(reset, preset, up, down)
  begin
    if rising_edge(reset) then
        reg <= (others => '0');
    end if;
    if not reset = '1' then
        if rising_edge(preset) then
          reg <= unsigned(input);
        elsif rising_edge(up) then
          reg <= reg + 1;
        elsif rising_edge(down) then
          reg <= reg - 1;
        end if;
    end if;
  end process;
 
  output <= std_logic_vector(reg) after DELAY; 
  zero <= '1' when (reg = "0") else '0' after DELAY;

end rtl;
