library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity counter_74163 is

	generic (
        WIDTH : integer;
        DELAY : time
	); 

	port (
		output   : out std_logic_vector (WIDTH-1 downto 0);
		input    : in std_logic_vector (WIDTH-1 downto 0);
		clk		 : in std_logic;
		cet		 : in std_logic;
		cep		 : in std_logic;
		sr_n	 : in std_logic;
		pe_n     : in std_logic;
		tc	     : out std_logic
	);

end counter_74163;

architecture rtl of counter_74163 is
	
	signal reg : unsigned (WIDTH-1 downto 0);
	
begin
  
  process(clk)
  begin
    if rising_edge(clk) then
        if sr_n = '0' then
            reg <= (others => '0');
        elsif pe_n = '0' then
          reg <= unsigned(input);
        elsif cet = '1' and cep = '1' then
          reg <= reg + 1;
        end if;
    end if;
  end process;
 
  output <= std_logic_vector(reg) after DELAY; 
  tc <= '1' after DELAY when (reg+1 = "0") else '0' after DELAY;

end rtl;
