library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity counter_74191 is

	generic (
        WIDTH : integer;
        DELAY : time
	); 

	port (
		output   : out std_logic_vector (WIDTH-1 downto 0);
		input    : in std_logic_vector (WIDTH-1 downto 0);
		clk		 : in std_logic;
		cten_n	 : in std_logic;
		du_n	 : in std_logic;
		load_n	 : in std_logic;
		rco_n    : out std_logic;
		minmax   : out std_logic
	);

end counter_74191;

architecture rtl of counter_74191 is
	
	signal reg : unsigned (WIDTH-1 downto 0);
	
begin
  
    process(clk, load_n)
    begin
        if load_n'event and load_n='1' then
            reg <= unsigned(input);
        elsif clk'event and clk = '1' and cten_n = '0' then
            if du_n = '0' then
                reg <= reg + 1;
            else
                reg <= reg - 1;
            end if;
        end if;
    end process;

    output <= std_logic_vector(reg) after DELAY when(load_n = '1') else
            input after DELAY; 
    minmax <= '1' after DELAY when(reg = "0" and du_n = '1') else
              '1' after DELAY when(reg+1 = "0" and du_n = '0') else
              '0' after DELAY;
    rco_n <= '0' after DELAY when(reg = "0" and du_n = '1' and clk = '0' and cten_n = '0') else
             '0' after DELAY when(reg+1 = "0" and du_n = '0' and clk = '0' and cten_n = '0') else
             '1' after DELAY;

end rtl;
