library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity counter_74590 is

	generic (
        DELAY : time
	); 

	port (
		output   : out std_logic_vector (7 downto 0);
		oe_n	 : in std_logic;
		rclk	 : in std_logic;
		cclk	 : in std_logic;
		ccken_n	 : in std_logic;
		cclr_n	 : in std_logic;
        rco_n    : out std_logic
	);

end counter_74590;

architecture rtl of counter_74590 is
	
	signal counter : unsigned (7 downto 0);
	signal reg : std_logic_vector (7 downto 0);
	
begin
  
  process(cclk, rclk, cclr_n)
  begin

    if cclr_n = '0' then
        counter <= (others => '0');
    elsif cclk'event and cclk = '1' and ccken_n = '0' then
        counter <= counter + 1;
    end if;

    if rclk'event and rclk = '1' then
        reg <= std_logic_vector(counter);
    end if;

  end process;
 
  output <= reg after DELAY when (oe_n = '0') else (others => 'Z') after DELAY; 
  rco_n <= '0' after DELAY when (counter = "00000000") else '1' after DELAY;

end rtl;
