library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity dff is

    generic (
        WIDTH : integer;
        DELAY : time
    ); 

    port (
        output   : out std_logic_vector (WIDTH-1 downto 0);
        input    : in std_logic_vector (WIDTH-1 downto 0);
        oe_n	 : in std_logic;
        clk	     : in std_logic
    );

end ;

architecture rtl of dff is

    signal reg : std_logic_vector (WIDTH-1 downto 0);

begin

    process(clk)
    begin
        -- update data on rising edge
        if clk'event and clk = '1' then
            reg <= input;
        end if;
    end process;

    output <= (others => 'Z') after DELAY when (oe_n = '1') else
              reg after DELAY;

end rtl;
