library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity latch is

    generic (
        WIDTH : integer;
        DELAY : time
    ); 

    port (
        output   : out std_logic_vector (WIDTH-1 downto 0);
        input    : in std_logic_vector (WIDTH-1 downto 0);
        oe_n	 : in std_logic;
        le	     : in std_logic
    );

end latch;

architecture rtl of latch is

    signal reg : std_logic_vector (WIDTH-1 downto 0);

begin

    process(le)
    begin
        -- latch input on falling edge
        if le'event and le = '0' then
            reg <= input;
        end if;
    end process;

    output <= (others => 'Z') after DELAY when (oe_n = '1') else
              reg after DELAY when (le = '0') else
              input after DELAY;

end rtl;
