library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
 
entity adder_tb is
end entity;
 
architecture TB of adder_tb is
    
	component adder is

        generic (
            WIDTH : integer;
            DELAY : time
        ); 

        port (
            a        : in std_logic_vector (WIDTH-1 downto 0);
            b        : in std_logic_vector (WIDTH-1 downto 0);
            s        : out std_logic_vector (WIDTH-1 downto 0);
            c_out    : out std_logic;
            c_in     : in std_logic
        );

    end component;
            
    signal a        : std_logic_vector (7 downto 0);
    signal b        : std_logic_vector (7 downto 0);
    signal s        : std_logic_vector (7 downto 0);
    signal c_out    : std_logic;
    signal c_in     : std_logic;

begin

	a1 : adder generic map (WIDTH => 8, DELAY => 8 ns) port map (a, b, s, c_out, c_in);

    process
    begin
        a <= X"00";
        b <= X"00";
        c_in <= '0';
		wait for 50 ns;
        a <= X"02";
        b <= X"03";
		wait for 50 ns;
        c_in <= '1';
		wait for 50 ns;
        c_in <= '0';
        a <= X"00";
        b <= X"FF";
		wait for 50 ns;
        a <= X"01";
        b <= X"FF";
		wait for 50 ns;
        a <= X"FF";
        b <= X"FF";
		wait for 50 ns;
    end process;

end;
