library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
 
entity buff_tb is
end entity;
 
architecture TB of buff_tb is
    
	component buff is
        generic (
            WIDTH : integer;
            DELAY : time
        ); 

        port (
            output   : out std_logic_vector (WIDTH-1 downto 0);
            input    : in std_logic_vector (WIDTH-1 downto 0);
            oe_n	 : in std_logic
        );
    end component;
        
    signal output   : std_logic_vector (7 downto 0);
    signal input    : std_logic_vector (7 downto 0);
    signal oe_n	    : std_logic;

begin

	b : buff generic map (WIDTH => 8, DELAY => 8 ns) port map (output, input, oe_n);

    process
    begin
        oe_n <= '0';
        input <= X"50";
		wait for 50 ns;
        input <= X"51";
		wait for 50 ns;
        -- go HiZ 
        oe_n <= '1';
		wait for 50 ns;
    end process;

end;
