library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
 
entity counter_74163_tb is
end entity;
 
architecture TB of counter_74163_tb is

	component counter_74163 is
        generic (
            WIDTH : integer;
            DELAY : time
        ); 

        port (
            output   : out std_logic_vector (WIDTH-1 downto 0);
            input    : in std_logic_vector (WIDTH-1 downto 0);
            clk		 : in std_logic;
            cet		 : in std_logic;
            cep		 : in std_logic;
            sr_n	 : in std_logic;
            pe_n     : in std_logic;
            tc	     : out std_logic
        );

	end component;
			
	signal output 	: std_logic_vector (3 downto 0);
	signal input    : std_logic_vector (3 downto 0);
	signal clk	 	: std_logic;
	signal cet	 	: std_logic := '1';
	signal cep	 	: std_logic := '1';
	signal sr_n	 	: std_logic := '1';
	signal pe_n	 	: std_logic := '1';
	signal tc	 	: std_logic;
 
begin

	c1 : counter_74163 generic map (WIDTH => 4, DELAY => 3 ns) port map (output, input, clk, cet, cep, sr_n, pe_n, tc);
    
    -- clock 
    process
    begin
        clk <= '0';
        wait for 10 ns;
        clk <= '1';
        wait for 10 ns;
    end process;

    process
    begin
        -- synchronous reset
        sr_n <= '0';
        wait for 15 ns;
        sr_n <= '1';
        wait for 100 ns;
        -- synchronous preload
        input <= X"E";
        wait for 150 ns;
        pe_n <= '0';
        wait for 15 ns;
        pe_n <= '1';
        wait for 200 ns;
    end process;

end;
