library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
 
entity counter_74191_tb is
end entity;
 
architecture TB of counter_74191_tb is

	component counter_74191 is
        generic (
            WIDTH : integer;
            DELAY : time
        ); 

        port (
            output   : out std_logic_vector (WIDTH-1 downto 0);
            input    : in std_logic_vector (WIDTH-1 downto 0);
            clk		 : in std_logic;
            cten_n	 : in std_logic;
            du_n	 : in std_logic;
            load_n	 : in std_logic;
            rco_n    : out std_logic;
            minmax   : out std_logic
        );
	end component;
			
	signal output 	: std_logic_vector (3 downto 0);
	signal input    : std_logic_vector (3 downto 0);
	signal clk	 	: std_logic;
	signal cten_n 	: std_logic := '0';
	signal du_n	 	: std_logic := '0';
	signal load_n 	: std_logic := '1';
	signal rco_n	: std_logic;
	signal minmax 	: std_logic;
 
begin

	c1 : counter_74191 generic map (WIDTH => 4, DELAY => 3 ns) port map (output, input, clk, cten_n, du_n, load_n, rco_n, minmax);
    
    -- clock 
    process
    begin
        clk <= '0';
        wait for 10 ns;
        clk <= '1';
        wait for 10 ns;
    end process;

    process
    begin
        input <= X"C";
        load_n <= '0';
        wait for 15 ns;
        load_n <= '1';
        wait for 100 ns;
        load_n <= '0';
        du_n <= '1';
        input <= X"2";
        wait for 15 ns;
        load_n <= '1';
        wait for 100 ns;
    end process;

end;
