library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
 
entity counter_74590_tb is
end entity;
 
architecture TB of counter_74590_tb is

	component counter_74590 is
        generic (
            DELAY : time
        ); 

        port (
            output   : out std_logic_vector (7 downto 0);
            oe_n	 : in std_logic;
            rclk	 : in std_logic;
            cclk	 : in std_logic;
            ccken_n	 : in std_logic;
            cclr_n	 : in std_logic;
            rco_n    : out std_logic
        );

	end component;
            
    signal output       : std_logic_vector (7 downto 0);
    signal oe_n	        : std_logic := '0';
    signal rclk	        : std_logic;
    signal cclk	        : std_logic;
    signal ccken_n	    : std_logic := '0';
    signal cclr_n	    : std_logic := '1';
    signal rco_n        : std_logic;
 
begin

	c1 : counter_74590 generic map (DELAY => 3 ns) port map (output, oe_n, rclk, cclk, ccken_n, cclr_n, rco_n);
    
    -- clock 
    process
    begin
        cclk <= '0';
        rclk <= '0';
        wait for 10 ns;
        cclk <= '1';
        rclk <= '1';
        wait for 10 ns;
    end process;

    process
    begin
        wait for 10 ns;
        -- clear
        cclr_n <= '0';
        wait for 10 ns;
        cclr_n <= '1';
        wait for 50 ns;
        -- disable count
        ccken_n <= '1';
        wait for 50 ns;
    end process;

end;
