library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
 
entity counter_tb is
end entity;
 
architecture TB of counter_tb is

	component counter is
		generic (
            WIDTH : integer := 8;
            DELAY : time
        ); 
		port (
			output   : out std_logic_vector (WIDTH-1 downto 0);
			zero	 : out std_logic;
			input    : in std_logic_vector (WIDTH-1 downto 0);
			up		 : in std_logic;
			down	 : in std_logic;
			reset	 : in std_logic;
			preset	 : in std_logic
		);
	end component;
			
	signal output 	: std_logic_vector (7 downto 0);
	signal zero	 	: std_logic;
	signal input    : std_logic_vector (7 downto 0) := X"00";
	signal up		: std_logic := '0';
	signal down	 	: std_logic := '0';
	signal reset	: std_logic := '0';
	signal preset	: std_logic := '0';
 
begin

	c1 : counter generic map (WIDTH => 8, DELAY => 5 ns) port map (output, zero, input, up, down, reset, preset);

    process
    begin
		-- reset the chip
		wait for 10 ns;
		reset <= '1';
		wait for 10 ns;
		reset <= '0';
		-- count up
		up <= '1';
		wait for 10 ns;
		up <= '0';
		wait for 10 ns;
		-- count up
		up <= '1';
		wait for 10 ns;
		up <= '0';
		-- count down
		down <= '1';
		wait for 10 ns;
		down <= '0';
		-- preset a value
		input <= X"42";
		wait for 10 ns;
		preset <= '1';
		wait for 10 ns;
		preset <= '0';
		-- count up
		up <= '1';
		wait for 10 ns;
		up <= '0';
		-- reset
		reset <= '1';
		wait for 10 ns;
		reset <= '0';
    end process;

end;
