library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
 
entity latch_tb is
end entity;
 
architecture TB of latch_tb is
    
	component latch is
        generic (
            WIDTH : integer;
            DELAY : time
        ); 

        port (
            output   : out std_logic_vector (WIDTH-1 downto 0);
            input    : in std_logic_vector (WIDTH-1 downto 0);
            oe_n	 : in std_logic;
            le	     : in std_logic
        );
    end component;
        
    signal output   : std_logic_vector (7 downto 0);
    signal input    : std_logic_vector (7 downto 0);
    signal oe_n	    : std_logic;
    signal le	    : std_logic;

begin

	l1 : latch generic map (WIDTH => 8, DELAY => 8 ns) port map (output, input, oe_n, le);

    process
    begin
        -- transparent mode
        input <= X"42";
        oe_n <= '0';
        le <= '1';
		wait for 50 ns;
        input <= X"43";
		wait for 50 ns;
        input <= X"44";
		wait for 50 ns;
        -- go HiZ in transparent mode
        oe_n <= '1';
		wait for 50 ns;

        -- latch mode
        oe_n <= '0';
        le <= '1';
        input <= X"50";
		wait for 50 ns;
        le <= '0';
		wait for 50 ns;
        input <= X"51";
		wait for 50 ns;
        -- go HiZ in latch mode
        oe_n <= '1';
		wait for 50 ns;
    end process;

end;
